' Draw equiangular spiral
' Programmed by Julien Moog - julien.moog@laposte.net

$optimize on
$apptype gui
$typecheck off
$include "rapidq2.inc"
$include "rq-math.inc"

declare sub drawspiral(rotation as double)
declare function degtorad(deg as double) as double
declare sub paintcanvas
declare sub formresizesub

create form as qform
    width=1024
    height=768
    onresize=formresizesub
    create canvas as qcanvas
        width=form.width-30
        height=form.height-30
        onpaint=drawspiral
    end create
end create

sub formresizesub
    canvas.width=form.width-30
    canvas.height=form.height-30
end sub

type pointstype
    r as double
    x as double
    y as double
end type 
    
dim points(0 to 500) as pointstype       

sub DrawSpiral(rotation as double) 
    
    dim b as double:b=DegToRad(80)
    dim a as double:a=rotation
    dim i as integer
    for i=0 to 500
        dim t as double:t=a*rqPI/4
        dim r as double:r = exp(t*cot(b+rotation))
        points(i).r = r+canvas.width/2
        points(i).x = r * cos(t)+canvas.width/2
        points(i).y = r * sin(t)+canvas.height/2
        a += 0.2
    next i
    'moveTo(points[0], points[1]);
    for i=1 to 500
       'moveTo(points[0].x, points[0].y);        
       'lineTo(points[i].x, points[i].y); 
       canvas.line(points(i-1).x,points(i-1).y,points(i).x,points(i).y,rgb(0,0,0))
    next i
end sub

function DegToRad(deg as double)
    result= deg*rqPI/180
end function

'DrawSpiral

sub paintcanvas
    dim i as double
    for i=0 to 1 step 1
        canvas.FillRect(0,0,canvas.width,canvas.height,rgb(255,255,255))
        DrawSpiral(i)
    next i
end sub

form.showmodal
